/*
** Copyright 1998 - 1999 Double Precision, Inc.  See COPYING for
** distribution information.
*/

#include	"auth.h"
#include	"courierauthdebug.h"
#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	<ctype.h>
#include	<errno.h>

static const char rcsid[]="$Id: authmoduser3.c,v 1.5 2004/10/21 00:10:49 mrsam Exp $";

extern int auth_generic(const char *service,
			const char *authtype,
			char *authdata,
			int (*callback_func)(struct authinfo *, void *),
			void *callback_arg);

static int badstr(const char *p)
{
	while (p && *p)
	{
		if ((int)(unsigned char)*p < ' ')
			return 1;
		++p;
	}
	return 0;
}

int auth_login(const char *service,
	       const char *userid,
	       const char *passwd,
	       int (*callback_func)(struct authinfo *, void *),
	       void *callback_arg)

{
	char	*p;
	int rc;

	if (badstr(userid) || badstr(passwd))
	{
		errno=EINVAL;
		return -1;
	}

	p=malloc(strlen(userid)+strlen(passwd)+3);
	courier_authdebug_login_init();
	courier_authdebug_login( 1, "username=%s", userid );
	courier_authdebug_login( 2, "password=%s", passwd );

	if (!p)
		return (-1);

	strcat(strcat(strcat(strcpy(p, userid), "\n"), passwd), "\n");

	rc=auth_generic(service, AUTHTYPE_LOGIN, p,
			callback_func,
			callback_arg);
	free(p);
	return rc;
}
