/*$Id: logmsg.c,v 1.3 1999/12/23 02:40:57 lindberg Exp $*/
/*$Name: ezmlm-idx-040 $*/
#include "stralloc.h"
#include "fmt.h"
#include "subscribe.h"
#include "errtxt.h"
#include <unistd.h>
#include <sybfront.h>
#include <sybdb.h>

static stralloc logline = {0};
static strnum[FMT_ULONG];

char *logmsg(dir,num,listno,subs,done)
/* creates an entry for message num and the list listno and code "done". */
/* Returns NULL on success, "" if dir/sql was not found, and the error   */
/* string on error.   NOTE: This routine does nothing for non-sql lists! */
char *dir;
unsigned long num;
unsigned long listno;
unsigned long subs;
int done;
{
  char *table = (char *) 0;
  char *ret;

  int return_code;

  if ((ret = opensql(dir,&table))) {
    if (*ret)
      return ret;
    else
      return (char *) 0;	/* no SQL => success */
  }
  if (!stralloc_copys(&logline,"INSERT INTO ")) return ERR_NOMEM;
  if (!stralloc_cats(&logline,table)) return ERR_NOMEM;
  if (!stralloc_cats(&logline,"_mlog (msgnum,listno,subs,done) VALUES ("))
	return ERR_NOMEM;
  if (!stralloc_catb(&logline,strnum,fmt_ulong(strnum,num))) return ERR_NOMEM;
  if (!stralloc_cats(&logline,",")) return ERR_NOMEM;
  if (!stralloc_catb(&logline,strnum,fmt_ulong(strnum,listno)))
	return ERR_NOMEM;
  if (!stralloc_cats(&logline,",")) return ERR_NOMEM;
  if (!stralloc_catb(&logline,strnum,fmt_ulong(strnum,subs))) return ERR_NOMEM;
  if (!stralloc_cats(&logline,",")) return ERR_NOMEM;
  if (done < 0) {
    done = - done;
    if (!stralloc_append(&logline,"-")) return ERR_NOMEM;
  }
  if (!stralloc_catb(&logline,strnum,fmt_uint(strnum,done))) return ERR_NOMEM;
  if (!stralloc_append(&logline,")")) return ERR_NOMEM;

  if (!stralloc_0(&logline)) return ERR_NOMEM;

  dbcmd((DBPROCESS *)psql,logline.s);
  if ( dbsqlexec((DBPROCESS *)psql) == FAIL ) {
    return("dbsqlexec failed 4");
  }

  if ((return_code=dbresults((DBPROCESS *)psql))==FAIL) {
    return("dbresults failed");
  } else {
    if (!stralloc_copys(&logline,"SELECT msgnum FROM ")) return ERR_NOMEM;
    if (!stralloc_cats(&logline,table)) return ERR_NOMEM;
    if (!stralloc_cats(&logline,"_mlog WHERE msgnum = ")) return ERR_NOMEM;
    if (!stralloc_catb(&logline,strnum,fmt_ulong(strnum,num)))
      return ERR_NOMEM;
    if (!stralloc_cats(&logline," AND listno = ")) return ERR_NOMEM;
    if (!stralloc_catb(&logline,strnum,fmt_ulong(strnum,listno)))
      return ERR_NOMEM;
    if (!stralloc_cats(&logline," AND done = ")) return ERR_NOMEM;
    if (!stralloc_catb(&logline,strnum,fmt_ulong(strnum,done)))
      return ERR_NOMEM;
    /* Query */
    if (!stralloc_0(&logline)) return ERR_NOMEM;

    dbcmd((DBPROCESS *)psql,logline.s);
    if ( dbsqlexec((DBPROCESS *)psql) == FAIL ) 
      return("dbsqlexec failed 5");
    if ((return_code=dbresults((DBPROCESS *)psql))==FAIL)
      return("dbresults failed");
    while( dbnextrow((DBPROCESS *)psql) != NO_MORE_ROWS);
    if (DBCOUNT((DBPROCESS *)psql)<1) 
      return("error");

    dbcancel((DBPROCESS *)psql);
  }
  dbcancel((DBPROCESS *)psql);

  return (char *) 0;
}
