sub clamdscan_scanner {
  #Clamdscan scanner
  &debug("clamdscan: starting scan of directory \"$ENV{'TMPDIR'}\"...");

  my ($start_clamdscan_time)=[gettimeofday];
  my ($DD,$clamdscan_status,$stop_clamdscan_time,$clamdscan_time);
  my ($clamdscan_verbose,$clamdscan_status);
  $clamdscan_verbose="-v" if ($DEBUG);

  &debug("run $clamdscan_binary $clamdscan_options  $ENV{'TMPDIR'} 2>&1");

  $DD=`$clamdscan_binary $clamdscan_options $ENV{'TMPDIR'} 2>&1`;
  $clamdscan_status=($? >> 8);

  &debug("--output of clamdscan was:\n$DD--");

  if ( $clamdscan_status > 0 ) {
    if ($clamdscan_status == 1 && $DD =~ /\:\s(.*)\sFOUND$/m) {
      $quarantine_description=$+;
      &debug("There be a virus! ($quarantine_description)");
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="CLAMDSCAN:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---clamdscan results ---\n$DD";
    } else {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("clamdscan: corrupt or unknown clamd scanner error or memory/resource/perms problem - exit status $clamdscan_status");
    }
  } else {
    if ($DD =~ /Recursion limit exceeded/) {
      $quarantine_description="Resource attack - $1";
      &debug("clamdscan: $quarantine_description");
      $quarantine_event="CLAMDSCAN:Resource_attack";
      $description .= "\n---clamdscan results ---\n$DD";
    }
  }
  #Bugs in clamdscan sometimes shows up as zero output. Always error on such conditions
  $DD=~s/\n//g;
  if ($DD eq "" ) {
    &error_condition("clamdscan: corrupt or unknown clamd scanner error or memory/resource/perms problem - exit status $clamdscan_status, but no output!");
  }
  
  $stop_clamdscan_time=[gettimeofday];
  $clamdscan_time = tv_interval ($start_clamdscan_time, $stop_clamdscan_time);
  &debug("clamdscan: finished scan of dir \"$ENV{'TMPDIR'}\" in $clamdscan_time secs");
}
