sub fprot_scanner {
  #F-prot scanner
  &debug("fprot: starting scan of directory \"$ENV{'TMPDIR'}\"...");

  my ($start_fprot_time)=[gettimeofday];
  my ($DD,$fprot_status,$stop_fprot_time,$fprot_time,$fprot_verbose);
  $fprot_verbose="-list" if ($DEBUG);

  &debug("run $fprot_binary  $fprot_verbose -archive -dumb  $ENV{'TMPDIR'}  2>&1");

  $DD=`$fprot_binary -ai -archive -dumb  $ENV{'TMPDIR'} 2>&1`;
  $fprot_status=($? >> 8);

  &debug("--output of fprot was:\n$DD--");


  if ( $fprot_status > 0 ) {
    if ($DD =~ /Infection:(.*)|(is a\s+.*)|(could be\s+.*)|(Infected:\s+[^0]+)|(Suspicious:\s+[^0]+)$/m) {
      $quarantine_description=$+;
      $quarantine_description=~s/^\s+//g;
      &debug("There be a virus! ($quarantine_description)");
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="FPROT:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---fprot results ---\n$DD";
    }

    else {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("corrupt or unknown F-Prot scanner error or memory/resource/perms problem - exit status $fprot_status");
    }  
  }


  $stop_fprot_time=[gettimeofday];
  $fprot_time = tv_interval ($start_fprot_time, $stop_fprot_time);
  &debug("fprot: finished scan of dir \"$ENV{'TMPDIR'}\" in $fprot_time secs");
}
