
sub check_and_grab_uuencoding {
  #This finds MIME messages banged onto the bottom of bounces
  if (/^\-\-\- Below this line is a copy of the message|^(MIME-Version|Content-Type):/) {
    $contains_rfc822++;
    &debug("c_a_g: found hidden MIME attachment") if ($contains_rfc822 == 2);
  }
  #This finds BinHex attachments
  if (/^\(This file must be converted with BinHex/) {
    $contains_rfc822 += 2;
    &debug("c_a_g: found hidden BinHex attachment") if ($contains_rfc822 == 2);
  }
  my ($begin,$perms,$uufile,$uuextension,$uulength,$uuencoded_attachments,$begin_content);
  if (/^(begin) ([0-9][0-9][0-9]) (.*)\n$/) {
    &debug("Ooohhhh, a uuencoded attachment!");
    #Better reset this message back to potentially having attachments
    $plain_text_msg=0;
    $uuencoded_attachments++;
    $begin=$1;
    $perms=$2;
    $uufile=tolower($3);
    push(@uufile_list, $uufile) if(!grep(/^$uufile$/,@uufile_list));
    return if (!$uudecode_binary);
    $uufile=~s/[^0-9a-z\_\-\.]/_/gi;
    $uufile =~ /\.([^\.]+)$/;
    $uuextension=$1;
    #Ensure the file extension isn't too long either...
    $uuextension=substr($uuextension,0,20); 
    $uulength=length($uufile);
    #Ensure the filelength isn't too large!
    if ( $uulength > $MAX_FILE_LENGTH) {
      &debug("uudecode output: gah! filename is > $MAX_FILE_LENGTH (actually $uulength), chopping...");
      $uufile=substr($uufile,0,$MAX_FILE_LENGTH).".".$uuextension;
    }
    if (! -f "$ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile.uue") {
      open(UUIN,">$ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile.uue")||&error_condition("cannot open $ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile.uue - $!");
    } else {
      &error_condition("$ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile.uue already exists! - $!");
    }
    print UUIN "$begin 600 $uufile\n";
    print TMPFILE;
    $begin_content = "uuencode";
    while (<STDIN>) {
      if ($begin_content eq "uuencode" && $_ =~ /^(M35JJ|M35J0|M35KU|M35H\\|M35HN)/i) {
	&debug("w_c: looks like a Windows executable, filename=$uufile");
      }
      print UUIN;
      print TMPFILE;
      if (/^end/) {
	close(UUIN)||&error_condition("cannot close $ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile - $!");
	#uudecode it - toss away the error code - who cares if it's broken...
	&debug("c_a_g_u: $uudecode_binary $uudecode_pipe $ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile.uue");
	open(UUOUT,"$uudecode_binary $uudecode_pipe $ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile.uue|");
	open(UUFILE,">$ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile");
	while (<UUOUT>) {
	  print UUFILE;
	}
	close UUOUT;
	close UUFILE;
	&debug("deleting uuencoded file as we have a decoded version of it now");
	unlink("$ENV{'TMPDIR'}/$file_id-$uuencoded_attachments-$uufile.uue") if ($DEBUG < 100);
	last;
      }
    }
  }
}

